package com.coydone.servlet;

import com.coydone.domain.User;
import com.coydone.utils.SendMail;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebServlet(urlPatterns = "/registerServlet.do")
public class RegisterServlet extends HttpServlet {
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doGet(request, response);
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.setCharacterEncoding("UTF-8");
        response.setContentType("text/html;charset=UTF-8");
        //接受用户请求
        String username = request.getParameter("username");
        String password = request.getParameter("password");
        String email = request.getParameter("email");

        User user = new User(username, password, email);

        //用户注册成功后，给用户发送一封邮件
        //我们使用线程来专门发送邮件，防止出现耗时，和网站注册人数过多的情况
        SendMail send = new SendMail(user);
        //启动线程，线程启动之后会执行run方法来发送邮件
        send.start();

        //注册用户
        request.setAttribute("message","注册成功，我们已经发送了一封带有注册信息的电子邮件，请及时查看！");
        request.getRequestDispatcher("/info.jsp").forward(request,response);


    }
}
