package com.coydone.utils;

import com.coydone.domain.User;
import com.sun.mail.util.MailSSLSocketFactory;

import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import java.security.GeneralSecurityException;
import java.util.Properties;

//多线程实现用户较好的体验（异步处理）
public class SendMail extends Thread {
    //用于给用户发送邮件的邮箱
    private String from = "coydone@qq.com";

    private String to = "coydone@163.com";
    //邮箱的用户名
    private String username = "coydone";
    //邮箱的密码 授权码
    private String password = "授权码";
    //发送邮箱的服务器地址
    private String host = "smtp.qq.com";

    private User user;

    public SendMail(User user){
        this.user = user;
    }

    //重写run()方法实现，在run()方法中发送邮件给指定的用户
    @Override
    public void run() {
        try {
            Properties prop = new Properties();
            prop.setProperty("mail.host",host);
            prop.setProperty("mail.transport.protocol","smtp");
            prop.setProperty("mail.smtp.auth","true");

            //关于QQ邮箱，还要设置SSL加密，加上以下代码即可
            MailSSLSocketFactory sf = new MailSSLSocketFactory();

            sf.setTrustAllHosts(true);
            prop.put("mail.smtp.ssl.enable","true");
            prop.put("mail.smtp.ssl.socketFactory",sf);

            //使用JavaMail发送邮件的5个步骤
            //1、创建定义整个应用程序所需的环境信息的Session对象
            //QQ才有，其它邮箱就不用
            Session session = Session.getDefaultInstance(prop,new Authenticator(){
                //发件人的邮箱用户名、授权码
                public PasswordAuthentication getPasswordAuthentication(){
                    return new PasswordAuthentication(username,password);
                }
            });

            //开启Session的debug模式，这样就可以查看到程序发送Email的运行状态
            session.setDebug(true);

            //2、通过session得到transport对象
            Transport ts = session.getTransport();

            //3、使用邮箱的用户名和授权码连上邮件服务器
            ts.connect(host,username,password);

            //4、创建邮件
            //创建邮件对象
            MimeMessage message = new MimeMessage(session);
            //指明邮件的发件人
            message.setFrom(new InternetAddress(from));
            //指明邮件的收件人
            message.setRecipient(Message.RecipientType.TO,new InternetAddress(to));
            //邮件的标题
            message.setSubject("用户注册邮件");
            //邮件的文本内容
            String info = "恭喜您注册成功，您的用户名："+user.getUsername()+",您的密码："+user.getPassword()+",请妥善保管，如有问题请联系我们!";
            message.setContent(info,"text/html;charset=UTF-8");
            //5、发送邮件
            ts.sendMessage(message,message.getAllRecipients());
            ts.close();
        } catch (GeneralSecurityException e) {
            e.printStackTrace();
        } catch (MessagingException e) {
            e.printStackTrace();
        }
    }
}
